# lmbMonth
**Класс lmbMonth** — предназначен для упрощения работы с одним календарным месяцем.

## Инициализация
В качестве параметров конструктора lmbMonth может получать или год с месяцем, или timestamp даты, или строку с датой в ISO-формате. Например:

    lmb_require('limb/datetime/src/lmbMonth.class.php');
    $month1 = new lmbMonth(2007, 2); // Февраль 2007
    $month2 = new lmbMonth(time()); // Текущий месяц.
    $month2 = new lmbMonth('2007-02-12'); // Февраль 2007

lmbMonth самостоятельно находит первый и конечный день указанного месяца.

## Методы класса lmbMonth
* **getMonth()** — возвращает номер месяца (1 - Январь)
* **getMonthName()** — возвращает полное название месяца, получение при помощи php функции date()
* **getMonthShortName()** — возвращает укороченное название месяца, полученное при помощи php функции date
* **getNextMonth()** — возвращает объект класса lmbMonth с последующим месяцем
* **getPrevMonth()** — возвращает объект класса lmbMonth с предыдущим месяцем
* **getNumberOfWeeks()** — возвращает общее количество недель в месяце (включая неполные).
* **getNumberOfDays()** — возвращает количество дней в месяце.
* **getWeek($n)** — возвращает массив объектов класса [lmDate](./lmb_date.md), которые соответствуют дням недели, с номером $n ($n начинается с 0).
* **getAllWeeks()** — возвращает массив (недели) массивов (дни) дат со всеми днями недель месяца.
