# Русский
## Limb PHP Framework
Limb (Library of Interdependent Modules and Blocks) — это [OpenSource](http://en.wikipedia.org/wiki/OpenSource) ([LGPL](http://en.wikipedia.org/wiki/LGPL)) фреймворк, ориентированный на быстрое прототипирование и разработку веб-приложений на PHP5. Limb содержит множество относительно независимых компонентов, пригодных для повторного использования. В том числе вместе с другими фреймворками и библиотеками.
* [Введение](./ru/for_beginners.md)
* [FAQ](./ru/faq.md)
* [Документация](./ru.md)
* [Пример 1. Создание простейшего CRUD-приложения](./ru/tutorials/basic.md)
* [Пример 2. Создание электронного магазина](./ru/tutorials/shop.md)
* [CodeBits](./ru/codebits.md)
* [Скачать](./ru/how_to_download.md)
* [Issue tracker](https://github.com/limb-php-framework/limb/issues)

##Limb CMS
Независимая [CMS](http://en.wikipedia.org/wiki/CMS), основанная на Limb PHP Framework.
* [Документация](../cms/docs/ru/cms.md)
* [Скачать](https://github.com/limb-php-framework/limb-cms/downloads)
* [Issue tracker](https://github.com/limb-php-framework/limb-cms/issues)

## Testman
testman — набор средств для организации и запуска SimpleTest тестов для приложений, которые содержат большие тестовые наборы. В поставку входят классы, которые позволяют выполнять тесты в cli или web-режиме.
* [Документация](../tests_runner/docs/ru/tests_runner.md)
* [Скачать](https://github.com/limb-php-framework/limb-app-testman/downloads)
* [Issue tracker](https://github.com/limb-php-framework/limb-app-testman/issues)

## Taskman
Утилита taskman является аналогом ant, pake, etc и предназначен для выполнения абстрактных «задач».
* [Документация](../taskman/docs/ru/taskman.md)
* [Скачать](https://github.com/limb-php-framework/limb-app-taskman/downloads)
* [Issue tracker](https://github.com/limb-php-framework/limb-app-taskman/issues)

#English
##Limb PHP Framework
Limb is an [OpenSource](http://en.wikipedia.org/wiki/OpenSource) ([LGPL](http://en.wikipedia.org/wiki/LGPL)) Library of Interdependent Modules and Blocks mostly aimed for rapid web application prototyping and development with PHP5.
Limb consists of many reusable components and you can cherry pick the ones you need and combine them with other frameworks and libraries (e.g. [Zend Framework](http://en.wikipedia.org/wiki/Zend_Framework), [Symfony](http://en.wikipedia.org/wiki/Symfony), [PEAR](http://en.wikipedia.org/wiki/PEAR), etc).
If you would like to see Limb in action have a look at CodeBits section where you can find code samples as well as applications built on this framework.
The easiest way to get almost immediate feedback from core Limb developers is to ask your question at the [GitHub](https://github.com/limb-php-framework/limb/issues). Don't hesitate asking even the most trivial questions and issues — we're there to help you.

* [Introduction](./en/for_beginners.md)
* [Roadmap](./roadmap.md)
* [Documentation](./en.md)
* [FAQ](./en/faq.md)
* [CRUD — basic example of Limb3](./en/tutorials/basic.md)
* [CodeBits](./en/codebits.md)
* [Download](./en/how_to_download.md)
* [All limb projects](https://github.com/limb-php-framework)
